/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
*
* \brief  AVR259: ATtiny40 QTouchQƊ݌v
*
*	̧ق͐ڐGνĉp܂݂܂B
*
* \par pLq:
*      AVR259: ATtiny40 QTouchQƊ݌v
*
* \author
*	O				: PC\n
*	Atmel Corporation	: http://www.atmel.com \n
*	xEҰ			: touch@atmel.com
*
* $Revision: 1.1 $
* $Date: 2010-11-07 13:21:17 +0730  $  \n
* 쌠 (c) 2010, Atmel Corporation S\ς
*
* 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	 Ȃ΂Ȃ܂B
*
* 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	 ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
* 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	 (ۏ)ɎgpłȂ܂B
*
* ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
* ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
* mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
* ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
* fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
* RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
* Ȃł傤B
*****************************************************************************/

/************************************************************************//**
 * ݸٰ ̧
****************************************************************************/

#include "ioavr.h"
#include <intrinsics.h>

#ifdef TWI_INTERFACE
#include "TWI_Slave.h"
#endif
#include "board_config.h"
#include "touch_lib_k.h"

/************************************************************************//**
 * 萔
****************************************************************************/

#define TICKS_PER_MS			4u
#define MEASUREMENT_PERIOD_MS	25u

/************************************************************************//**
 * ^
****************************************************************************/

static void init_system( void );									// νĉpA݂Ȃǂ
static void init_timer0_isr( void );								// /0PWMɌ`Ԑݒ
static void init_timer1_isr( void );

static void start_pwm_timer ( void );								// ΉPWMJn
static void pwm_idle_state ( void );								// PWM ُԐݒ
static void buzzer_pwm_control( void );								// xJnPWMlݒ

#ifndef TWI_INTERFACE
/* ޯފ֐ */
static void report_debug_data( void );
static void output_to_debugger( const uint8_t *p, uint8_t count );
static void send_debug_byte( uint8_t data );
#endif

/************************************************************************//**
 * ^`
****************************************************************************/

/************************************************************************//**
 * ϸ
****************************************************************************/

/************************************************************************//**
 * Sϐ
****************************************************************************/

/************************************************************************//**
 * ÓIϐ
****************************************************************************/

/* ڐG̎Ԃ̎/ISRɂĐݒ肳׸ */
static uint8_t time_to_measure_touch = 0u;

/* /ISRɂĐݒ肳錻ݎ */
static uint16_t current_time_ms = 0u;

static uint8_t pwm_limit[2] = {0x00u, 0x00u};

static uint8_t touch_data_buffer = 0u;

/************************************************************************//**
* O	: main\n
*------------------------------------------------------------------------------\n
* ړI	: 庰ޓ_\n
* 	: Ȃ\n
* o	: Ȃ\n
* 	: \n
****************************************************************************/
__task void main( void )
{
	init_system();				// νĉpA݂Ȃǂ

	/* m0`7:0`7̷ */
	qt_enable_key( CHANNEL_0, AKS_GROUP_1, 15u, HYST_6_25 );
	qt_enable_key( CHANNEL_1, AKS_GROUP_1, 15u, HYST_6_25 );
	qt_enable_key( CHANNEL_2, AKS_GROUP_1, 15u, HYST_6_25 );
	qt_enable_key( CHANNEL_3, AKS_GROUP_1, 15u, HYST_6_25 );
	qt_enable_key( CHANNEL_4, AKS_GROUP_1, 15u, HYST_6_25 );
	qt_enable_key( CHANNEL_5, AKS_GROUP_1, 15u, HYST_6_25 );
	qt_enable_key( CHANNEL_6, AKS_GROUP_1, 15u, HYST_6_25 );
	//qt_enable_key( CHANNEL_7, AKS_GROUP_1, 10u, HYST_6_25 );	// PWMƂĎgp

	qt_init_sensing();			// ڐGm

	init_timer0_isr();			// /0PWMɌ`Ԑݒ
	init_timer1_isr();			// /1 ISRKIȌpɌ`Ԑݒ

#ifdef TWI_INTERFACE
	TWI_slave_initialize();		// TWI]uҋ@Ԃɍ\ݒ
#endif

	__enable_interrupt();		// S̊荞݋

	/* JԂ */
	for( ; ; )
	{
		if( time_to_measure_touch )					// ڐG莞ԂȂA
		{
			time_to_measure_touch = 0u;				// ڐG莞׸މ
			qt_measure_sensors( current_time_ms );	// ڐGm푪
#ifndef TWI_INTERFACE
			report_debug_data();					// ޯ ްνĂ֕
#endif
			if (touch_data_buffer != (uint8_t)qt_touch_status.sensor_states[0])		// mωLŁA
			{
				touch_data_buffer = (uint8_t)qt_touch_status.sensor_states[0];		// mԂTWIɏՕ֕
#ifdef TWI_INTERFACE
				TWI_touch_status();					// IRQݐݒATWIɏՕi[ݒ
#endif
				buzzer_pwm_control();				// xJnPWMlݒ
			}
		}
#ifdef TWI_INTERFACE
		TWI_bus_error_check();						// TWI޽ُ팟
#endif
	}
}
/************************************************************************//**
* O	: init_timer0_isr\n
*------------------------------------------------------------------------------\n
* ړI	: /0PWMɌ`Ԑݒ\n
* 	: Ȃ\n
* o	: Ȃ\n
* 	:\n
****************************************************************************/
void init_timer0_isr( void )
{
	TCCR0A = (uint8_t)((1<<WGM01)|(1<<WGM00));		// PWM`Ԑݒ
}

/************************************************************************//**
* O	: init_timer1_isr\n
*------------------------------------------------------------------------------\n
* ړI	: /1 ISRKIȌpɌ`Ԑݒ\n
* 	: Ȃ\n
* o	: Ȃ\n
* 	:\n
****************************************************************************/

void init_timer1_isr( void )
{
	OCR1A = ( TICKS_PER_MS * MEASUREMENT_PERIOD_MS );		// rl(ISRpx)ݒ
	TIMSK_OCIE1A = 1u;										// T/C1rAv荞݋
	TCCR1A = (uint8_t) ((1<<CTC1) |(1<<CS12) | (1<<CS10));	// 1024ۯACTC`ԂŌvJn
}

/************************************************************************//**
* O	: init_system\n
*------------------------------------------------------------------------------\n
* ړI	: νĉpA݂Ȃǂ\n
* 	: Ȃ\n
* o	: Ȃ\n
* 	:\n
****************************************************************************/

void init_system( void )
{
	asm ("ldi r16, $D8");	// I/Oیڼ޽ɕύX[
	asm ("out 0x3c, r16");
	asm ("ldi r16, 1");		//  ۯOu2(=4MHz)ɐݒ
	asm ("out 0x36, r16");	// ([݌4ۯ)

#ifndef TWI_INTERFACE
	DDR_DBG_DATA = 1u;		// ޯޗpݏ
	DDR_DBG_CLK  = 1u;
#endif

   BUZ_DDR = 1u;			// xݏo͐ݒ

   PWM2_PORT = 1u;			// PWMݏl(=H)ݒ
   PWM1_PORT = 1u;
   PWM2_DDR  = 1u;			// PWMݏo͐ݒ
   PWM1_DDR  = 1u;

   PW_LED_PORT = 1u;		// dLEDݏl(=H(_))ݒ
   PW_LED_DDR = 1u;			// dLEDݏo͐ݒ

   TOUCH_LED_DDR = 1u;		// ڐGLEDݏo͐ݒ(=)
}
/************************************************************************//**
* O	: start_pwm_timer\n
*------------------------------------------------------------------------------\n
* ړI	: ΉPWMJn\n
* 	: Ȃ\n
* o	: Ȃ\n
* 	:\n
****************************************************************************/
void start_pwm_timer (void)
{
	/* PWM1Jn */
	if ( pwm_limit[0] )			// PWM1 ONȂA
	{
		OCR0A = pwm_limit[0];	// PWMlݒ
		TCCR0A_COM0A1 = 1u;		// 񔽓]
		TCCR0B_CS00 = 1u;		// vJn
	}
	/* PWM2Jn */
	else if ( pwm_limit[1] )	// PWM2 ONȂA
	{
		OCR0B = pwm_limit[1];	// PWMlݒ
		TCCR0A_COM0B1 = 1u;		// 񔽓]
		TCCR0B_CS00 = 1u;		// vJn
	}
}

/************************************************************************//**
* O	: pwm_idle_state\n
*------------------------------------------------------------------------------\n
* ړI	: PWM ُԐݒ\n
* 	: Ȃ\n
* o	: Ȃ\n
* 	:\n
****************************************************************************/
void pwm_idle_state ( void )
{
	TCCR0B = 0x00u;		// /0~
	TCNT0 = 0x00u;		// /0l
	TCCR0A &= (uint8_t) ~((1<<COM0A1)|(1<<COM0A0)|(1<<COM0B1)|(1<<COM0B0));	// ]
	PWM2_PORT = 1u;		// PWM2=Hݒ
	PWM1_PORT = 1u;		// PWM1=Hݒ
}

/************************************************************************//**
* O	: buzzer_pwm_control\n
*------------------------------------------------------------------------------\n
* ړI	: xJnPWMlݒ\n
* 	: Ȃ\n
* o	: Ȃ\n
* 	:\n
****************************************************************************/
void buzzer_pwm_control( void )
{
	uint8_t i;

	/* xONAPWM=LAPWMۯ~ */
	pwm_idle_state ();			// PWM ُԐݒ
	PWM2_PORT = 0u;				// PWM2ݏl(=L)ݒ
	PWM1_PORT = 0u;				// PWM1ݏl(=L)ݒ

	/* x30msON (̊ԒAڐGƱ۸ޏo͂͂Ȃ) */
	i = 240u;					// JԂ񐔐ݒ(30ms125s=240)
	do{
		BUZ_PIN = 1u;				// x=Hݒ(Jn)
		__delay_cycles( 500UL );	// 125sx
		i--;						// JԂvl
	}while (i>0);				// 240(30ms)JԂ
	BUZ_PORT = 0u;				// x=Lݒ(~)

	/* ۸ޏo͏ */
	switch (qt_touch_status.sensor_states[0])	// mԑΉ
	{
		case 0x01:					// KEY0ŁA
			pwm_limit[0]= 0x80u;	// PWM1=2.5Vw
			break;
		case 0x02:					// KEY1ŁA
			pwm_limit[0]= 0x64u;	// PWM1=2.0Vw
			break;
		case 0x04:					// KEY2ŁA
			pwm_limit[0]= 0x49u;	// PWM1=1.5Vw
			break;
		case 0x08:					// KEY3ŁA
			pwm_limit[0]= 0x33u;	// PWM1=1.0Vw
			break;
		case 0x10:					// KEY5ŁA
			pwm_limit[1]= 0x80u;	// PWM2=2.5Vw
			break;
		case 0x20:					// KEY6ŁA
			pwm_limit[1]= 0x64u;	// PWM2=2.0Vw
			break;
		case 0x40:					// KEY7ŁA
			pwm_limit[1]= 0x49u;	// PWM2=1.5Vw
			break;
		default:
			pwm_limit[0]= 0x00u;	// PWM1=0Vw
			pwm_limit[1]= 0x00u;	// PWM2=0Vw
			break;
	}
	/* ڐGoȂΐڐGLED_APWM(۸)o */ 
	if ((uint8_t)(pwm_limit[0]|pwm_limit[1]))	// ꂩ̷ڐGŁA
	{
		TOUCH_LED_PORT = 1u;	// ڐGLED_
		start_pwm_timer();		// ΉPWMo͊Jn
	}
	/* ڐGoȂȂAڐGLEDAPWM(۸)oOFF(o=5V) */
	else
	{
		TOUCH_LED_PORT = 0u;	// ڐGLED
		pwm_idle_state();		// PWM ُԐݒ
	}
}
/************************************************************************//**
* O	: timer_isr\n
------------------------------------------------------------------------------\n
* ړI	: /1荞ݏٰ\n
* 	: \n
* o	: \n
* 	: \n
****************************************************************************/

#pragma vector=TIM1_COMPA_vect

__interrupt void timer1_isr( void )
{
	time_to_measure_touch = 1u;					// ڐG莞׸ސݒ
	current_time_ms += MEASUREMENT_PERIOD_MS;	// ݎԍXV
}

#ifndef TWI_INTERFACE
/************************************************************************//**
* O	: report_debug_data\n
*------------------------------------------------------------------------------\n
* ړI	: νĂޯ ް\n
* 	: Ȃ\n
* o	: Ȃ\n
* 	: Ȃ\n
****************************************************************************/

void report_debug_data( void )
{
   output_to_debugger( (uint8_t *) channel_signals, (uint8_t) sizeof( channel_signals ) );
   output_to_debugger( (uint8_t *) channel_references, (uint8_t) sizeof( channel_references ) );
   output_to_debugger( (uint8_t *) sensor_deltas, (uint8_t) sizeof( sensor_deltas ) );
   output_to_debugger( (uint8_t *) &qt_touch_status, (uint8_t) sizeof( qt_touch_status ) );
}

/************************************************************************//**
* O	: output_to_debugger\n
*------------------------------------------------------------------------------\n
* ړI	: ޯ ̪֕޲đM\n
* 	: p		= M޲Ăւ߲\n
*         count	= M޲Đ\n
* o	: Ȃ\n
* 	: \n
****************************************************************************/

void output_to_debugger( const uint8_t *p, uint8_t count )
{
	uint8_t i;
	uint8_t data;

	for( i = 0u; i < count; i++ )	// w޲Đp
	{
		data = *p;					// Ήoް ޲Ď擾
		send_debug_byte( data );	// ޯ ̪޲đM
		p++;						// ߲is
	}
}

/************************************************************************//**
* O	: send_debug_byte\n
*------------------------------------------------------------------------------\n
* ړI	: ޯ ̪֒P޲đM\n
* 	: data = M޲\n
* o	: Ȃ\n
* 	: \n
****************************************************************************/

void send_debug_byte( uint8_t data )
{
	uint8_t i;

	for( i = 0u; i < 8u; i++ )						// 1޲(8ޯ)M
	{
		/* ޯ ް 0/1ݒ */
		if( data & 0x80u )							// Ήޯ=1ŁA
		{
			DBG_DATA = 1u;							// ޯ ް=Hݒ
		}
		else										// Ήޯ=0ŁA
		{
			DBG_DATA = 0u;							// ޯ ް=Lݒ
		}
		__delay_cycles( 10UL );						// ۯOݒ莞(2.5s)ҋ@
		data = (uint8_t)( data << 1u );				// ް ޲ ޯĈʒuړ(MSB=Ώޯ)

		/* ޯ ۯ ٽo */
		DBG_CLK = 1u;								// ޯ ۯ=H()
		__delay_cycles( 10UL );						// ٽ(2.5s)ҋ@
		DBG_CLK = 0u;								// ޯ ۯ=L()

		__delay_cycles( 10UL );						// ۯێ(2.5s)ҋ@
	}
	DBG_DATA = 0u;									// (޲ĊԒlp)ޯ ް=Lݒ
	__delay_cycles( 50UL );							// ޲Ċ(12.5s)ҋ@
}
#endif